/*
 * page.h
 *
 *  Created on: 08.07.2010
 *      Author: vdv
 */

#ifndef WEBGUI_PAGE_H_
#define WEBGUI_PAGE_H_

#include <string>

#include "platform.h"
#include "microhttpd.h"

#define POSTBUFFERSIZE  1024

#define METHOD_UNKNOWN 0
#define METHOD_GET     1
#define METHOD_POST    2

#define PAGE_TITLE "PAGE TITLE"

extern bool reboot;

struct connection_info_struct
{
	struct MHD_PostProcessor *postprocessor;
	FILE* file_ptr;
	void (*post_completed)(connection_info_struct* con_info);
	void* data;
};

typedef struct
{
	const char* wwwpage;
	size_t name_size;
	std::string (*get)(const char*);
	MHD_PostDataIterator (*post)(const char* url, connection_info_struct* con_info);
} page_struct;

const page_struct* get_page_ptr(const char* url, page_struct* pages, size_t size);

void post_page_prepare(const char* url, struct MHD_Connection *connection, connection_info_struct* con_info);

int get_page(const char* url, struct MHD_Connection *connection);

#endif /* WEBGUI_PAGE_H_ */
